<?php

function mlm_ezmlm_info() {
  return (object) array(
    'name'            =>  t('ezmlm'),
    'supported_types' => array('announcement', 'discussion'),
  );
}

function mlm_ezmlm_create_form($node) {
  $form = array();
  $form['mlm_ezmlm_address'] = array(
    '#type'         => 'textfield',
    '#title'        => t('E-mail Address'),
    '#default_value'=> $node->mlm_ezmlm->address,
    '#description'  => t(''),
    '#required'     => TRUE,
  );
  return $form;
}

function mlm_ezmlm_create_form_validate($node) {
  if (!valid_email_address($node->mlm_ezmlm_address)) {
    form_set_error('mlm_ezmlm_address', t('Invalid mail address format'));
  }
}

function mlm_ezmlm_subscribe($list, $user) {
  $mail = is_object($user) ? $user->mail : $mail;
  $action = '-subscribe-'.str_replace('@', '=', $mail);
  $address = str_replace('@', "{$action}@", $list->mlm_ezmlm->address);
  return mimemail($user, $address, 'unsubscribe');
}

function mlm_ezmlm_unsubscribe($list, $user) {
  $mail = is_object($user) ? $user->mail : $mail;
  $action = '-unsubscribe-'.str_replace('@', '=', $mail);
  $address = str_replace('@', "{$action}@", $list->mlm_ezmlm->address);
  return mimemail($user, $address, 'unsubscribe');
}

function mlm_ezmlm_post($list, $mail, $subject, $body) {
  return mimemail($mail, $list->mlm_ezmlm->address, $subject, $body);
}